class LBASE
{
 
 constructor (data) 
 {
  this.d=data; 
  this.id=data.id;
  this.par=data.par;
  this.childs=[];
  this.msg=[];
  
  this.dtime=new Date();   


  
  // dtime.s=0; dtime.e=0; dtimex=0;
  
  
 } 
  //msg handling
  
  addMsg (msg)
  {this.msg[msg.id]=msg;}    
  
  addChild (wat)
  {this.childs[wat.id]=wat;this.childs[wat.id].p=this}  
  
 triggerMsg(trigger)
 {
  for (let key in this.msg) 
  { //if (trigger=="mis")console.log(this);
   if (this.msg[key].trigger==trigger && !this.msg[key].mlock) 
   { 
    if (this.msg[key].delay)
    {setTimeout(this.sendMsg.bind(this),this.msg[key].delay*1000,this.msg[key]);} 
    else 
    {this.sendMsg(this.msg[key])} 
   }  
    
  } 
 }
 
 //------
 
 sendMsg(msg)
 {//console.log(msg)
  if (!msg.mlock) 
  {
   switch (msg.handler) 
   {    
    case 'SELF': this.getMsg(msg); break;
    case 'PARENT':  this.p.getMsg(msg);   break;
    case 'PPARENT':  this.p.p.getMsg(msg);  break;
    case 'CORE': CORE.getMsg(msg); break;
    case 'ROOM': ROOMS[AKROOM].room.getMsg(msg); break;
   }  
  } 
 } 
 
 //--
 
 getMsg(msg)
 {//console.log(this.id,msg)
  for (let key in msg.dest)
  { // console.log(msg.dest[key])
   if (msg.dest[key]=='SELF') 
   {this.parseMsg(msg); }
   else
   {
    for (let key2 in this.childs) 
    { 
     if (key2==msg.dest[key]) 
     { 
       this.childs[key2].parseMsg(msg)
     }
    }  
   }  
  } 
 }
 
 //--
 
 parseMsg(msg)
 { 
  if (msg.log) {console.log('id',this.id);console.log(msg)}
  switch (msg.act) 
  {    
   case "startDtime": this.startDTime();  break;
   case "endDtime":  this.endDTime(); break;
   case "loadroom":  newRoom(msg.val); console.log(msg.val); break;


  }     
  
 }      
   
 //---- timers
 
 startDTime(){this.dtime.d=new Date()}   
 endDTime() {this.dtime.x=new Date()-this.dtime.d;  }

 
}   



//--------------------------------------------------------------------------------------

class LSOUND extends LBASE
{

 constructor(data)
 {
   super (data);
  this.sound = document.createElement("audio");
  this.sound.src = data.src;
  this.sound.setAttribute("preload", "auto");
  this.sound.setAttribute("controls", "none");
  this.sound.style.display = "none";
  this.sound.volume = data.volume ? data.volume : 0.2;
  this.sound.loop = data.loop ? data.loop : false;
  document.body.appendChild(this.sound);   
  
  if (data.mute) {this.sound.muted=true;}
   
 
   
 }   
  
  parseMsg(msg)
 { 
  super.parseMsg(msg); 
  if (msg.log) {console.log('id',this.id);console.log(msg)}
  switch (msg.act) 
  {    
   case "play": this.sound.play();  break;
   case "soundoff" :this.sound.muted=true; break;
   case "soundon" :this.sound.muted=false; break;   


  }     
  
 }  
  
}   
